package cassandra

import (
	cnsmc "git.loafle.net/commons/service_matcher-go/cassandra"
	ocsm "git.loafle.net/overflow/commons-go/sensorconfig/model"
	"git.loafle.net/overflow/container_network/crawler/health"
	crawler "git.loafle.net/overflow/crawler-go"
)

type CassandraHealthCrawler struct {
	health.SocketHeahthCrawler
}

func (c *CassandraHealthCrawler) Name() string {
	return "CASSANDRA_HEALTH"
}

func (c *CassandraHealthCrawler) String() string {
	return "Cassandra Health Crawler"
}

func (c *CassandraHealthCrawler) Auth(auth map[string]string) error {
	return nil
}

func (c *CassandraHealthCrawler) Get(config *ocsm.SensorConfig) (map[string]string, error) {
	rss, err := c.CheckHeahth(config)
	if err != nil {
		return nil, err
	}
	return rss, nil
}

func NewCrawler() crawler.Crawler {
	c := &CassandraHealthCrawler{}
	c.SetMatcher(cnsmc.NewMatcher())
	return c
}
