package ldap

import (
	cnsml "git.loafle.net/commons/service_matcher-go/ldap"
	ocsm "git.loafle.net/overflow/commons-go/sensorconfig/model"
	"git.loafle.net/overflow/container_network/crawler/health"
	crawler "git.loafle.net/overflow/crawler-go"
)

type LDAPHealthCrawler struct {
	health.SocketHeahthCrawler
}

func (c *LDAPHealthCrawler) Name() string {
	return "LDAP_HEALTH"
}

func (c *LDAPHealthCrawler) String() string {
	return "Active Directory Health Crawler"
}

func (c *LDAPHealthCrawler) Auth(auth map[string]string) error {
	return nil
}

func (c *LDAPHealthCrawler) Get(config *ocsm.SensorConfig) (map[string]string, error) {
	rss, err := c.CheckHeahth(config)
	if err != nil {
		return nil, err
	}
	return rss, nil
}

func NewCrawler() crawler.Crawler {
	c := &LDAPHealthCrawler{}
	c.SetMatcher(cnsml.NewMatcher())
	return c
}
