package netbios

import (
	cnsmn "git.loafle.net/commons/service_matcher-go/netbios"
	ocsm "git.loafle.net/overflow/commons-go/sensorconfig/model"
	"git.loafle.net/overflow/container_network/crawler/health"
	"git.loafle.net/overflow/crawler-go"
)

type NetBIOSHealthCrawler struct {
	health.SocketHeahthCrawler
}

func (c *NetBIOSHealthCrawler) Name() string {
	return "NETBIOS_HEALTH"
}

func (c *NetBIOSHealthCrawler) String() string {
	return "NetBIOS Health Crawler"
}

func (c *NetBIOSHealthCrawler) Auth(auth map[string]string) error {
	return nil
}

func (c *NetBIOSHealthCrawler) Get(config *ocsm.SensorConfig) (map[string]string, error) {
	rss, err := c.CheckHeahth(config)
	if err != nil {
		return nil, err
	}
	return rss, nil
}

func NewCrawler() crawler.Crawler {
	c := &NetBIOSHealthCrawler{}
	c.SetMatcher(cnsmn.NewMatcher())
	return c
}
